#include <X11/Intrinsic.h>
#include <Xm/List.h>

typedef struct {
  char *label;
  WidgetClass *class;
  char mnemonic;
  char *accelerator;
  char *accel_text;
  void (*callback) ();
  int callback_data;
} MenuItem;



/*function prototypes */
Widget CreateRCTA(Widget, Widget, char*,int);
Widget CreateLabelText(Widget, char*, double, int, int, int);
Widget CreateDialog(Widget,char*,int,int,Widget);
Widget CreateMenu(Widget,int,char*,char,MenuItem*);
Widget CreateToggleB(Widget,char*,int,int);
Widget CreatePushB(Widget,char*,int);
Widget CreateHRowCol(Widget,Widget);
Widget CreateVRowCol(Widget,Widget);
Widget CreateVRowCol2(Widget);
Widget CreateMainRowCol(Widget);
Widget CreateRightRowCol(Widget,Widget);
Widget CreateFrame(Widget);
Widget CreateForm(Widget,int);
Widget CreatePane(Widget);
Widget CreateLabel(Widget,char*);
Widget CreateTextInfo(Widget,int,int,int,int);
Widget CreateScale(Widget,int,int,int,char*,int);
void SizeMaster(Widget,XtPointer,XEvent*);

void XtSetup(int, char**);
void SetupGraphics();

void OpenDialog(Widget, Widget, char*);
XmStringTable BuildTschemeList(int*);
void OpenParamDialog(Widget menu_item,XtPointer client_data,
			   XtPointer call_data);
void OpenSeamDialog(Widget,XtPointer,XtPointer);
void OpenAniDialog(Widget,XtPointer,XtPointer);
void OpenEventsDialog(Widget,XtPointer,XtPointer);
void OpenStrainDialog(Widget,XtPointer,XtPointer);
void OpenTempDialog(Widget,XtPointer,XtPointer);
void OpenModDialog(Widget,XtPointer,XtPointer);
void OpenZoomDialog(Widget,XtPointer,XtPointer);
void OpenColorDialog(Widget,XtPointer,XtPointer);
void OpenTrackDialog(Widget,XtPointer,XtPointer);
void OpenNebDialog(Widget,XtPointer,XtPointer);
void OpenTestDialog(Widget,XtPointer,XtPointer);

void SetupColors(int);
void DrawColorBar();
int gtype(double);
int RedrawPlot(int, int, int, int, double*, int, int, double*, double*, 
	       int, int, int); 
void UpdatePlot(int);

void UpdateTextInfos(double,double);
void KinkFinder();
void RedrawnebPlot();
void Redraw();
void Refresh();
void RefreshPlot();
void RefreshnebPlot();
double calccolindex(double, double, double);
void HSL_to_RGB(double, double, double, double*, double*, double*);
