#include "gvar.h"

#define YPLOTFRACTION 0.3         /* Factor used to create space  
				     for plots in drawing area.  */
#define MINPLOTRANGE 0.00000001 



/*-----------------------------------------------------------------*/
/*-----------------------------------------------------------------*/

/* colors */

typedef struct {
  double r,g,b;
} RGBstruct;

#define MAXRGB 65535
#define COLORBARWIDTH 100     /*colorbar width in pixels*/
#define COLORS 1253  /*61*/          /*amount of colors in atom drawing*/

#define BACKGROUND COLORS+1         /*some colors...*/        
#define RED        COLORS+2
#define BLUE       COLORS+3
#define BLACK      COLORS+4
#define FIXEDB     COLORS+5
#define FIXEDT     COLORS+6
#define FORCE1     COLORS+7
#define FORCE2     COLORS+8
#define SELECT     COLORS+9     

#define LASTCOLOR  COLORS+10        /*size of color array*/

/*
#define COLORS 253
#define BACKGROUND 254
#define FIXED 255
#define BTYPE 256
#define BLACK 257
*/

/*-----------------------------------------------------------------*/
/*-----------------------------------------------------------------*/

 /* an array holding information for text widgets:
   the order of its must agree with definitions in control.h */
Container c[] = {
  {NULL, NULL,NULL, 5,TAND,  &size.x,            2.0,    9999.9, 1.0},
  {NULL, NULL,NULL, 5,TAND,  &size.y,            2.0,    9999.9, 1.0},
  {NULL, NULL,NULL, 5,TANMD, &seam.rotL,         -180.0, 180.0,  1.0},
  {NULL, NULL,NULL, 5,TANMD, &seam.rotR,         -180.0, 180.0,  1.0},
  {NULL, NULL,NULL, 5,TANMD, &seam.disp.x,       -15.0,  15.0,   0.5},
  {NULL, NULL,NULL, 5,TANMD, &seam.disp.y,       -15.0,  15.0,   0.1},
  {NULL, NULL,NULL, 5,TANMD, &crack.center.x,    -999.9, 999.9,  0.1},
  {NULL, NULL,NULL, 5,TANMD, &crack.center.y,    -999.9, 999.9,  0.1},
  {NULL, NULL,NULL, 5,TANMD, &crack.size.x,      0.0,    999.9,  0.1},
  {NULL, NULL,NULL, 5,TANMD, &crack.size.y,      0.0,    999.9,  0.1},
  {NULL, NULL,NULL, 5,TANMD, &crack.angle,       -180.0, 180.0,  5.0},
  {NULL, NULL,NULL, 5,TAND,  &lParam,            0.2,    3.0,    0.1},
  {NULL, NULL,NULL, 5,TAND,  &cut,               0.9,    5.0,    0.1},
  {NULL, NULL,NULL, 5,TAND,  &epsilon,           0.1,    20.0,   1.0},
  {NULL, NULL,NULL, 5,TAND,  &borderW,           0.0,    3.0,    0.1},
  {NULL, NULL,NULL, 5,TANMD, &seam.boundpos,     -100,   100,    0.2},
  {NULL, NULL,NULL, 5,TAND,  &epsilon2,          0.1,    20.0,   0.01},
  {NULL, NULL,NULL, 5,TAND,  &lParam2,           0.2,    3,      0.01},
  {NULL, NULL,NULL, 5,TAND,  &relaxation,        0,      100,    20},
  {NULL, NULL,NULL, 5,TANMD, &seam.Amove,        -20.0,  20.0,   0.1},
  {NULL, NULL,NULL, 5,TANMD, &seam.Bmove,        -20.0,  20.0,   0.1},
  {NULL, NULL,NULL, 5,TANMD, &seam.downcut,      -20.0,  20.0,   0.2},
  {NULL, NULL,NULL, 5,TANMD, &seam.upcut,        -20.0,  20.0,   0.2},
  {NULL, NULL,NULL, 5,TANMD, &seam.downcuta,     -20.0,  20.0,   0.2},
  {NULL, NULL,NULL, 5,TANMD, &seam.upcuta,       -20.0,  20.0,   0.2},
  {NULL, NULL,NULL, 5,TANMD, &seam.dot,          0,      80,     1},
  {NULL, NULL,NULL, 5,TANMD, &strainP,           -50.0,  100.0,  1.0},
  {NULL, NULL,NULL, 5,TAN,   &strainT,           10.0,   100000.0, 100.0},
  {NULL, NULL,NULL, 5,TANMD, &pressure,          -200.0, 200.0,  1.0},
  {NULL, NULL,NULL, 5,TAND,  &zoom.x,            1.0,    9999.9, 1.0},
  {NULL, NULL,NULL, 5,TAND,  &zoom.y,            1.0,    9999.9, 1.0},
  {NULL, NULL,NULL, 5,TAND,  &avrCut,            0.0,    100.0,  0.5},   
  {NULL, NULL,NULL, 5,TAND,  &cool.tempvalue,    0,      10000,  1},
  {NULL, NULL,NULL, 5,TAND,  &cool.starttime,     0,      1000000, 20},
  {NULL, NULL,NULL, 5,TANMD, &cool.slope,        -10,    10,     0.001},
  {NULL, NULL,NULL, 5,TANMD, &cool.cooltemp,      0,      2000,   25},
  {NULL, NULL,NULL, 5,TAND,  &ani.waittime,      4,      20000,  50},
  {NULL, NULL,NULL, 5,TAND,  &ani.beginat,       4,      10000,  100},
  {NULL, NULL,NULL, 5,TAND,  &ani.endat,         4,100000000000, 1000},
  {NULL, NULL,NULL, 5,TANMD, &RRc,               1.0,    10,     0.2},
  {NULL, NULL,NULL, 5,TANMD, &PotFact,           0.3,    1.0,    0.01},
  {NULL, NULL,NULL, 5,TANMD, &BFactor,           1.0,    15.0,   0.2},
  {NULL, NULL,NULL, 5,TANMD, &modarea.center.x,  -999.9, 999.9,  0.5},
  {NULL, NULL,NULL, 5,TANMD, &modarea.center.y,  -999.9, 999.9,  0.5},
  {NULL, NULL,NULL, 5,TANMD, &modarea.size.x,    0.0,    999.9,  0.5},
  {NULL, NULL,NULL, 5,TANMD, &modarea.size.y,    0.0,    999.9,  0.5},
  {NULL, NULL,NULL, 5,TANMD, &modarea.angle,     -360.0, 360.0,  5.0},
  {NULL, NULL,NULL, 5,TANMD, &modvel.x,          -500.0,500.0,   0.1},
  {NULL, NULL,NULL, 5,TANMD, &modvel.y,          -500.0,500.0,   0.1},
  {NULL, NULL,NULL, 5,TAND,  &colorranges.EkMin, 0.0,    200.0,  0.1},
  {NULL, NULL,NULL, 5,TAND,  &colorranges.EkMax, 0.0,    200.0,  0.1},
  {NULL, NULL,NULL, 5,TANMD, &colorranges.EpMin, -10.0,  10.0,   0.1},
  {NULL, NULL,NULL, 5,TANMD, &colorranges.EpMax, -10.0,  10.0,   0.1},
  {NULL, NULL,NULL, 5,TANMD, &colorranges.SMin,  -200.0, 200.0,  1.0},
  {NULL, NULL,NULL, 5,TANMD, &colorranges.SMax,  -200.0, 200.0,  1.0},
  {NULL, NULL,NULL, 5,TAND,  &colorranges.FMin,  0.0,    100.0,  1.0},
  {NULL, NULL,NULL, 5,TAND,  &colorranges.FMax,  0.0,    100.0,  1.0},
  {NULL, NULL,NULL, 5,TAN,   &grImage,            0,    (20-1),  1},
  {NULL, NULL,NULL, 5,TAN,   &nebip1,            0,    (20-1),   1},
  {NULL, NULL,NULL, 5,TAN,   &nebip2,            0,    (20-1),   1},
  {NULL, NULL,NULL, 5,TAN,   &nebcpi,            0,    (20-1),   1},
  {NULL, NULL,NULL, 5,TAN,   &nebaddamount,       0,    100,     1},
  {NULL, NULL,NULL, 7,TAND,   &nebk,               0,    100000,      1},
  {NULL, NULL,NULL, 7,TAND,   &nebrepA,            0,    1000,      1},
  {NULL, NULL,NULL, 7,TAND,   &nebrepAlpha,        0,    50,      1},
  {NULL, NULL,NULL, 3,TAN,   &cgGraphSteps,        1,    90,      1}
};


/*-----------------------------------------------------------------*/
/*-----------------------------------------------------------------*/

MenuItem filemenu[] = {
  {"New...",&xmPushButtonGadgetClass,'N',NULL,NULL,CbMenu,M_NEW},
  {"",&xmSeparatorGadgetClass,'-',NULL,NULL,NULL,-1},
  {"Save snapshot",&xmPushButtonGadgetClass,'S',NULL,NULL,CbMenu,M_SNAPSHOT},
  {"Save animation...",&xmPushButtonGadgetClass,'a',NULL,NULL,CbMenu,
   M_ANIMATION},
  {"",&xmSeparatorGadgetClass,'-',NULL,NULL,NULL,-1},
  {"Exit",&xmPushButtonGadgetClass,'x',"Ctrl<Key>C","Ctrl+C",CbMenu,M_EXIT},
  NULL};

MenuItem controlsmenu[] = {
  {"Apply .events...",&xmPushButtonGadgetClass,'e',NULL,NULL,
   CbMenu,M_EVENTS},
  {"Pressure...",&xmPushButtonGadgetClass,'P',NULL,NULL,
   CbMenu,M_STRAIN},
  {"Temperature...",&xmPushButtonGadgetClass,'T',NULL,NULL,CbMenu,
   M_TEMPERATURE},
  {"Modify area...",&xmPushButtonGadgetClass,'M',NULL,NULL,CbMenu,M_NEWCRACK},
  {"NEB-method...",&xmPushButtonGadgetClass,'N',NULL,NULL,CbMenu,M_NEB},
  {"Reset time",&xmPushButtonGadgetClass,'R',NULL,NULL,CbMenu,M_RESETTIME},
  {"Test...",&xmPushButtonGadgetClass,'s',NULL,NULL,CbMenu,M_TEST},
  NULL};

MenuItem viewmenu[] = {
  {"Rescale plot",&xmPushButtonGadgetClass,'R',"Ctrl<Key>R","Ctrl+R",
   CbMenu,M_RESCALE},
  {"Manual zoom...",&xmPushButtonGadgetClass,'z',NULL,NULL,CbMenu,M_ZOOM},
  {"Color ranges...",&xmPushButtonGadgetClass,'C',NULL,NULL,CbMenu,M_COLOR},
  {"Track defects...",&xmPushButtonGadgetClass,'T',NULL,NULL,CbMenu,M_TRACK},
  NULL};

MenuItem displaymenu[] = {
  {"KinEnergy",&xmPushButtonGadgetClass,'K',NULL,NULL,CbMenu,M_KIN},
  {"PotEnergy",&xmPushButtonGadgetClass,'P',NULL,NULL,CbMenu,M_POT},
  {"Sigma xx",&xmPushButtonGadgetClass,'S',NULL,NULL,CbMenu,M_SIGMAXX},
  {"Sigma xy",&xmPushButtonGadgetClass,'x',NULL,NULL,CbMenu,M_SIGMAXY},
  {"Sigma yy",&xmPushButtonGadgetClass,'y',NULL,NULL,CbMenu,M_SIGMAYY},
  {"Atom type",&xmPushButtonGadgetClass,'A',NULL,NULL,CbMenu,M_ATOMTYPE},
  {"Force",&xmPushButtonGadgetClass,'F',NULL,NULL,CbMenu,M_FORCE},
  {"",&xmSeparatorGadgetClass,'-',NULL,NULL,NULL,-1},
  {"Vectors",&xmPushButtonGadgetClass,'V',NULL,NULL,CbMenu,M_VECTORS},
  NULL};

MenuItem modifymenu[] = {
  {"Remove area",      &xmPushButtonGadgetClass,'e',NULL,NULL,CbMenu,M_MODRM},
  {"Stop atoms",       &xmPushButtonGadgetClass,'S',NULL,NULL,CbMenu,M_MODSTOP},
  {"Change to type 1", &xmPushButtonGadgetClass,'1',NULL,NULL,CbMenu,M_MODTYPE1},
  {"Change to type 2", &xmPushButtonGadgetClass,'2',NULL,NULL,CbMenu,M_MODTYPE2},
  {"Add velocity",     &xmPushButtonGadgetClass,'v',NULL,NULL,CbMenu,M_MODVEL},
  {"Fix velocity",     &xmPushButtonGadgetClass,'F',NULL,NULL,CbMenu,M_MODFIX},
  {"Fix x-vel.",       &xmPushButtonGadgetClass,'x',NULL,NULL,CbMenu,M_MODFIXX},
  {"Fix y-vel.",       &xmPushButtonGadgetClass,'F',NULL,NULL,CbMenu,M_MODFIXY},
  {"Add const. force", &xmPushButtonGadgetClass,'A',NULL,NULL,CbMenu,M_MODFORCE},
  {"Remove fix./force",&xmPushButtonGadgetClass,'e',NULL,NULL,CbMenu,M_MODRMF},
  {"Move area",        &xmPushButtonGadgetClass,'M',NULL,NULL,CbMenu,M_MODMOVE},
  {"Tag area",         &xmPushButtonGadgetClass,'T',NULL,NULL,CbMenu,M_MODTAG},
  {"Rotate area",      &xmPushButtonGadgetClass,'R',NULL,NULL,CbMenu,M_MODROT},
  NULL};

/*-----------------------------------------------------------------*/
/*-----------------------------------------------------------------*/

/* global variables used in graphics.c */
Widget wTextInfo;
Widget wTextInfo2;
Widget wTextInfoT;
Widget wTextneb;
Widget wTextnebc;
Widget wTextEvents;
Widget wTop;
Widget wPlot;
Widget wRange,wnebPlot;
VecI wPlotSize,wRangeSize;
double cix0,ciy0; /* AK */
/*double cix0p,ciy0p;*/ /* Used to color code potential energy; 
		       read in from command line  */
double cix0p=0.25;     
double ciy0p=0.95;
double cix0o=0.0,ciy0o=0.0; /* Used to color code stresses and Ekin */
GC gc;            /* graphic context */
Pixel color[LASTCOLOR];
RGBstruct RGB[LASTCOLOR];
Pixmap pixmap,plpixmap,rangepixmap,nebpixmap;

typedef struct {int x1, y1, x2, y2;} PLine; /*used in plot drawing*/


