#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <limits.h>  /*DBL_MAX*/ 
#include <float.h>   /*DBL_MAX*/

#include "control.h"
/*#include "graphics.h"
#include "simu.h"
#include "fitsigma.h"
#include "calc.h"
#include "callback.h"*/
#include "track.h" 
#include "gvar.h"    /*load global variables*/

extern Container c[];

//extern VecD *ra;
//extern MtrxD *StressT;/*Stress Tensor*/

int LastNumber;
VecD *lastrTrk;
int *LastIndx;
int *PrtIndex;
int numdef;
VecD rcm2[MAXLABELS];
FILE *trF1;
int LastNumber;
VecD *lastrTrk;
int *LastIndx;
int *PrtIndex;
int AtomsinDefects;
int *SrtSet, *LastIndx,*PrtIndex;
MtrxD AvStressT,*AvSetStressT;
int *RIndx;
/*-------------Labeling Global Variables---------------*/
VecD rcm1[MAXLABELS], rcm2[MAXLABELS];
int /*label1[MAXLABELS],*/ label2[MAXLABELS];
int numdef, lastnumdef, totalcount;
/*-----------------------------------------------------*/


/*-----------------------------------------------------------------------*/
/*-----------------------------------------------------------------------*/
/*--------------Tracking Procedures (M Robles)-------------*/

void Trackprocedure()
{
  int i,j,k,l,ij,Flag,aux1;
  int SetCount,last;
  double distance,rsq;
  VecD rCM,fCM,rjk,fSet,VSet/*,VCM*helios*/;
  double dx,dy;
  
  ALLOC(rb, nAtom, VecD);
  ALLOC(RIndx,nAtom,int);
  for (i=0;i<nAtom;i++)  RIndx[i]=0;
  /*-Get atoms in possible defects-*/
  j=0;
  for (i=0;i<nAtom;i++) {   
    if (ae[i].potEn > (PotFact*potEnmin) && 
	fabs(ae[i].r.x) < (size.x/2.0-BFactor*borderW) && 
	fabs(ae[i].r.y) < (size.y/2.0-BFactor*borderW) ) {
      rb[j]=ae[i].r;
      RIndx[j]=i;
      j++;
    }
  };
  AtomsinDefects=j;
    
  /*-Tracking algoritm-*/
  
  if (AtomsinDefects>0) {
    ALLOC(SrtSet,2*AtomsinDefects,int);
    /*Initializing SrtSet*/
    for (i=0;i<2*AtomsinDefects;i++) {
      SrtSet[i]=-1;      
    };
    SrtSet[AtomsinDefects]=0;
    for (i=1;i<AtomsinDefects;i++) {
      j=0;Flag=0;aux1=0;
      while (aux1>-1) {
	k=SrtSet[AtomsinDefects+j];
	while (k>-1 && i>k) { 
	  dx=rb[i].x-rb[k].x;
	  dy=rb[i].y-rb[k].y;
	  distance=sqrt(dx*dx+dy*dy);
	  if (distance<RRc) {
	    if (SrtSet[i]==-1) {
	      SrtSet[i]=SrtSet[AtomsinDefects+j];
	      SrtSet[AtomsinDefects+j]=i;
	    } else {
	      l=i;
	      while (l>-1) {
		last=l;
		l=SrtSet[l];}
	      SrtSet[last]=SrtSet[AtomsinDefects+j];
	      for (ij=j;ij<AtomsinDefects-1;ij++) {
		SrtSet[ij+AtomsinDefects]=SrtSet[AtomsinDefects+1+ij];
	      }
	    }
	    k=-1;Flag=1;
	  } else {
	    k=SrtSet[k];
	  }
	}
	j++;
	if (SrtSet[AtomsinDefects+j]==-1 && Flag==0) {
	  SrtSet[AtomsinDefects+j]=i;
	  Flag=1;
	  aux1=SrtSet[AtomsinDefects+j+1];
	} else {
	  aux1=SrtSet[AtomsinDefects+j];
	}
      } 
    }
     
    SetCount=0;
    for (i=AtomsinDefects;i<2*AtomsinDefects;i++) {
      if (SrtSet[i]>-1) {
	SetCount++;
      }
    }
    NumberofDefects=SetCount;
    numdef = NumberofDefects;

    AvStressT.x.x=0;
    AvStressT.x.y=0;
    AvStressT.y.x=0;
    AvStressT.y.y=0;
    
    if (SetCount>0) {
      ALLOC(rTrk,SetCount,VecD);
      ALLOC(AvSetStressT,SetCount,MtrxD);
      ALLOC(effForce,SetCount,VecD);
      for (i=0;i<SetCount;i++) {
	rCM.x=0;rCM.y=0;aux1=0;
	VZero(fSet);
	VZero(VSet);
	j=SrtSet[AtomsinDefects+i];
	while (j>-1) {
	  rCM.x=rCM.x+rb[j].x;
	  rCM.y=rCM.y+rb[j].y;
	  VVSAdd(AvStressT.x,1,ae[RIndx[j]].StressT.x);
	  VVSAdd(AvStressT.y,1,ae[RIndx[j]].StressT.y);
	  VVSAdd(VSet,1,ae[RIndx[j]].ra);
	  k=SrtSet[AtomsinDefects+i];
	  VSet(fCM, ae[RIndx[j]].ra.x, ae[RIndx[j]].ra.y);
	  while (k>-1) {
	    if (j!=k) {
	      VSub(rjk,rb[j],rb[k]);
	      rsq=VLenSq(rjk);
	      VVSAdd(fCM,-12.0*UNITENERGY*(1.0/(rsq*rsq*rsq)-0.5)/
		     (rsq*rsq*rsq*rsq),rjk);
	    }
	    k=SrtSet[k];
	  }
	  VVSAdd(fSet,1,fCM);
	  j=SrtSet[j];
	  aux1++;
	};
	VSCopy(effForce[i],1.0/aux1,VSet);
	rTrk[i].x=rCM.x/(aux1);
	rTrk[i].y=rCM.y/(aux1);
	
	rcm2[i].x=rTrk[i].x;
	rcm2[i].y=rTrk[i].y;
	  
	AvSetStressT[i].x.x=AvStressT.x.x/aux1;
	AvSetStressT[i].x.y=AvStressT.x.y/aux1;
	AvSetStressT[i].y.x=AvStressT.y.x/aux1;
	AvSetStressT[i].y.y=AvStressT.y.y/aux1;
      }
    }
    
  } else {
    NumberofDefects=0;
    numdef=0;
  }
    
  label();
}

/*-----------------------------------------------------------------------*/
/*-----------------------------------------------------------------------*/


void label()
{
  int i, j, temp;
  double deltar;
  static int first=1;
  
  /*------alustus---------*/

  if (first==1) {
    for (i=0; i < numdef; i++) {
      rcm1[i].x = rcm2[i].x;
      rcm1[i].y = rcm2[i].y;
      label1[i]=label2[i]=i; /*More than one defect intially should work now.*/
    }
      
    label1[i] = i+1;
    label2[i] = i+1;
    lastnumdef = numdef;
    first=0;
  }
   
  for (i = 0; i < numdef; i++) {
    temp=0;
    for (j = 0; j < lastnumdef; j++) {
      deltar = sqrt( (rcm1[j].x - rcm2[i].x)*(rcm1[j].x - rcm2[i].x) + 
		     (rcm1[j].y - rcm2[i].y)*(rcm1[j].y - rcm2[i].y) );	
      if ( deltar < 0.5*RRc) {
	label2[i]=label1[j];	    
      } else {
	temp++;
      }
    }
    
    if (temp == lastnumdef) {
      totalcount++;
      label2[i] = totalcount; 
    }        
  }
  
  for (i = 0; i < numdef; i++) {
    rcm1[i].x = rcm2[i].x;
    rcm1[i].y = rcm2[i].y;
    label1[i] = label2[i];
  }
  lastnumdef = numdef;
}

/*-----------------------------------------------------------------------*/
/*-----------------------------------------------------------------------*/

void savingprogram()
{
  int i,j,Adds,Count,Temp;
  double dMin,dist/*,aux*helios*/;

  ALLOC(lastrTrk,NumberofDefects+LastNumber,VecD); 
  ALLOC(PrtIndex,NumberofDefects+LastNumber,int);
  ALLOC(LastIndx,NumberofDefects+LastNumber,int);

  /*  LastNumber=aux;*/

  if (StartFlag) {
    /*Initializing*/
    Adds=0;
    for (i=0;i<NumberofDefects+LastNumber;i++) {
      if (i<NumberofDefects) 
	PrtIndex[i]=i;
      else 
	PrtIndex[i]=-1;}
    /*Generating the printing array*/
    for (i=0;i<LastNumber;i++) {
      dMin=6;Count=0;
      if (LastIndx[i]>-1) {
	for (j=i;j<NumberofDefects+Adds;j++) {
	  dist=sqrt((lastrTrk[LastIndx[i]].x-rTrk[PrtIndex[j]].x)
		    *(lastrTrk[LastIndx[i]].x-rTrk[PrtIndex[j]].x)+
		    (lastrTrk[LastIndx[i]].y-rTrk[PrtIndex[j]].y)
		    *(lastrTrk[LastIndx[i]].y-rTrk[PrtIndex[j]].y));
	  if (dist<dMin && dist<3.5) {
	    Temp=PrtIndex[i];
	    PrtIndex[i]=PrtIndex[j];
	    PrtIndex[j]=Temp;
	    Count++;
	    dMin=dist;
	  }
	}
	if (Count==0) {
	  PrtIndex[NumberofDefects+Adds]=PrtIndex[i];
	  PrtIndex[i]=-1;
	  Adds++;}
      } else { 
	PrtIndex[NumberofDefects+Adds]=PrtIndex[i];
	PrtIndex[i]=-1;
	Adds++;}
    }

    /*Preparation for next time*/

    LastNumber=NumberofDefects+Adds;
    for (i=0;i<NumberofDefects+Adds;i++) {
      if (i<NumberofDefects) lastrTrk[i]=rTrk[i];
      LastIndx[i]=PrtIndex[i];     
    }
    
  } else {
    LastNumber=NumberofDefects;
    for (i=0;i<NumberofDefects;i++) {
      lastrTrk[i]=rTrk[i];
      LastIndx[i]=i;
      StartFlag=True;
    }        
  }
}

/*-----------------------------------------------------------------------*/
/*-----------------------------------------------------------------------*/

void savetrack(int ind, int *numero) {
  /*static int start = 1;*helios*/
  char nimi[16];
   
  sprintf(nimi,"TrkFile%04d.dat",label1[ind]);
  trF1 = fopen(nimi,"a");
  fprintf(trF1,"%d %d %g %g \n", label1[ind],stepCount, 
	  rTrk[ind].x,rTrk[ind].y);
  fclose(trF1);
    
}
